--[[		  
			Debuff category: 1024 is Corruption
			Debuff category: 4 is Physical
			Debuff category: 512 is Elemental
			Debuff category: 128 is Poison
			Debuff category: 8 is Wound
			Debuff category: 2 is Disease
			Debuff category: 64 is Fear
			Debuff category: 16 is Cry
			Debuff category: 32 is Song
			Debuff category: 0 is Undefined

		]]--

--Callback when Poisoned, etc.
function InitialiseDebuff()
	Debuff1 = AddCallback(effects, "EffectAdded",function(sender,args)
		--When an effect is added show all the bars that match that effect
		local cat=effects:Get(args.Index):GetCategory()
		local curable=effects:Get(args.Index):IsCurable()
		if cat==0 then return end	--Zero's are not indexed.
		if not curable then return end
		--Just scan the bars for this category
		for i=1,#Bar do
			if Bar[i].Data~=nil then
				if Bar[i].Data.Debuff==cat then Bar[i].Debuff=true Bar[i]:Show() end
				end
			end
		end)
		
	Debuff2 = AddCallback(effects, "EffectRemoved",function(sender,args)
		DebuffUpdate()
		end)
end

InitialiseDebuff()
	
function DebuffUpdate()
	--This function resets everything and searches for every category.
	--Is called on UI unlock or De/buff removal.
	--No easy way around this - debuff removal does not tell you the category of the buff removed.
		local n=effects:GetCount()

		local fx={}
		
		for i=1,n do
			local cat=effects:Get(i):GetCategory()
			if effects:Get(i):IsCurable() then
				fx[cat]=true
			end
		end
		
		for i=1,#Bar do
			if Bar[i].Data.Debuff~=nil then
				if fx[Bar[i].Data.Debuff] then Bar[i].Debuff=true Bar[i]:Show() else Bar[i].Debuff=false Bar[i]:Hide() end
			end
		end
end	

--Add the "Debuff Bar" option to every Bar.
table.insert(Context,
function (self,contextMenu,contextMenuItems)

	local DebuffBar = Turbine.UI.MenuItem( "Debuffed by...");
		contextMenu.Debuffs = DebuffBar:GetItems()
		DebuffMenu={}
		
		local function DOption(self,contextMenu,contextMenuItems,n)
		DebuffMenu[n]= Turbine.UI.MenuItem( Debufftext[2^n],true, self.Data.Debuff==2^n );
		DebuffMenu[n].Click = function( sender, args )
				if self.Data.Debuff==2^n then 
					self.Data.Debuff=nil
				else
					self.Data.Debuff=2^n
				end
			DebuffUpdate()
		end
			contextMenu.Debuffs:Add(DebuffMenu[n])
		end
		
		for i=1,10 do
			DOption(self,contextMenu,contextMenuItems,i)
		end

	contextMenuItems:Add( DebuffBar )
end)

DebuffUpdate()

--Option Box functions

table.insert(Opt.Module,
	function()
		Opt.DebuffCB=CollapseBox("Debuff Options","f",1,true)
		table.insert(Opt.source,"Debuff")
		Opt.ListBox:AddItem(Opt.DebuffCB)
			Opt.Debuff=Opt.DropDown(
			{	"Always show",
				"Disease",
				"Physical",
				"Wound",
				"Cry",
				"Song",
				"Fear",
				"Poison",
				"Elemental",
				"Corruption"},
			function(k,i)
				if k==0 then	
					Bar[i].Data.Debuff=nil
				else
					Bar[i].Data.Debuff=2^k
				end
			end,
			"Debuff:")
			Opt.DebuffCB.Content:AddItem(Opt.Debuff)
		end)
		
table.insert(Opt.Updaters, 
	function()
	if Opt.Debuff~=nil then
		local t
		if Opt.val.Debuff~=0 then t=math.log10(Opt.val.Debuff)/math.log10(2) else t=0 end
		Opt.Debuff:SetVal(t)
	end
end)
			
			